#include "itemscrollbox.h"
#include "ui_relayscrollbox.h"
#include "ui_relayscrollbox.h"
#include "../items/train.h"
#include "../items/turnout.h"
#include "../trainjs.h"

ItemScrollBox::ItemScrollBox(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::RelayScrollBox)
{
    ui->setupUi(this);
    QScroller::grabGesture(ui->scrollArea, QScroller::TouchGesture);
    QScroller::grabGesture(ui->scrollArea, QScroller::LeftMouseButtonGesture);
}

ItemScrollBox::~ItemScrollBox()
{
    delete ui;
}

void ItemScrollBox::addItem(std::weak_ptr<Item> item)
{
    if(auto workItem  = item.lock())
    {
        widgets_.push_back(new ItemWidget(item, this));
        Train* train = dynamic_cast<Train*>(workItem.get());
        Turnout* turnout = dynamic_cast<Turnout*>(workItem.get());
        if(train)
        {
            if(train->getTrainId() == 0)
                widgets_.back()->setShortcuts(QKeySequence(Qt::Key_Q), QKeySequence(Qt::Key_A), QKeySequence(Qt::Key_Z));
            else if(train->getTrainId() == 1)
                widgets_.back()->setShortcuts(QKeySequence(Qt::Key_W), QKeySequence(Qt::Key_S), QKeySequence(Qt::Key_X));
            else if(train->getTrainId() == 2)
                widgets_.back()->setShortcuts(QKeySequence(Qt::Key_E), QKeySequence(Qt::Key_D), QKeySequence(Qt::Key_C));
            else if(train->getTrainId() == 3)
                widgets_.back()->setShortcuts(QKeySequence(Qt::Key_R), QKeySequence(Qt::Key_F), QKeySequence(Qt::Key_V));
            else if(train->getTrainId() == 4)
                widgets_.back()->setShortcuts(QKeySequence(Qt::Key_T), QKeySequence(Qt::Key_G), QKeySequence(Qt::Key_B));
        }
        else if(turnout)
        {
            if(turnout->getTurnoutId() == 0)
                widgets_.back()->setShortcuts(QKeySequence(), QKeySequence(), QKeySequence(Qt::Key_1));
            else if(turnout->getTurnoutId() == 1)
                widgets_.back()->setShortcuts(QKeySequence(), QKeySequence(), QKeySequence(Qt::Key_2));
            else if(turnout->getTurnoutId() == 2)
                widgets_.back()->setShortcuts(QKeySequence(), QKeySequence(), QKeySequence(Qt::Key_3));
            else if(turnout->getTurnoutId() == 3)
                widgets_.back()->setShortcuts(QKeySequence(), QKeySequence(), QKeySequence(Qt::Key_4));
            else if(turnout->getTurnoutId() == 4)
                widgets_.back()->setShortcuts(QKeySequence(), QKeySequence(), QKeySequence(Qt::Key_5));
            else if(turnout->getTurnoutId() == 5)
                widgets_.back()->setShortcuts(QKeySequence(), QKeySequence(), QKeySequence(Qt::Key_6));
            else if(turnout->getTurnoutId() == 6)
                widgets_.back()->setShortcuts(QKeySequence(), QKeySequence(), QKeySequence(Qt::Key_7));
            else if(turnout->getTurnoutId() == 7)
                widgets_.back()->setShortcuts(QKeySequence(), QKeySequence(), QKeySequence(Qt::Key_8));
            else if(turnout->getTurnoutId() == 8)
                widgets_.back()->setShortcuts(QKeySequence(), QKeySequence(), QKeySequence(Qt::Key_9));
            else if(turnout->getTurnoutId() == 9)
                widgets_.back()->setShortcuts(QKeySequence(), QKeySequence(), QKeySequence(Qt::Key_0));
        }
        ui->relayWidgetVbox->addWidget(widgets_.back());
        connect(widgets_.back(), &ItemWidget::deleteRequest, this, &ItemScrollBox::deleteRequest);
        connect(widgets_.back(), &ItemWidget::deleteRequest, this, &ItemScrollBox::removeItem);
    }
}

void ItemScrollBox::removeItem(const ItemData& item)
{
    for(unsigned i = 0; i < widgets_.size(); i++)
    {
        if(widgets_[i]->controles(item))
        {
            ui->relayWidgetVbox->removeWidget(widgets_[i]);
            delete widgets_[i];
            widgets_.erase(widgets_.begin()+i);
        }
    }
}


