#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>
#include <QColorDialog>
#include <QListWidgetItem>
#include <QTime>
#include <QShortcut>
#include <vector>
#include "../microcontroller.h"
#include "../items/itemstore.h"


class MainObject;

namespace Ui
{
class MainWindow;
}

class MainWindow : public QMainWindow
{
    Q_OBJECT
    QShortcut stopShort;

public:
    explicit MainWindow(Microcontroller * const micro, ItemStore* items, QWidget *parent = nullptr);
    ~MainWindow();

private:
    Ui::MainWindow *ui;

    Microcontroller *_micro;

signals:

    void createdItem(std::shared_ptr<Item> item);

private slots:

    //void showItemCreationDialog();

};

#endif // MAINWINDOW_H

